* Logical ops
*
* pjwitte 2o23+
* All code is my own work except as and where stated
*
* V0,01, pjw, 1996 Apr 4
* V0.02, pjw, 2023 Aug 17, re-write. Split out BIT_
*
* Compatible with QDOS, Minerva and SMSQ/E
*


        section code

        xdef getops,fixpar

        include dev8_keys_sbasic
        include dev8_keys_qlv
        include dev8_keys_err

*
getops
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* result = LOG_XXX( op1 | n, op2 [,size%])
*
* where size = 8, 16, or 32. Default 32
*       n = +/-(number modulo 32) for shifts and rotates
*           + => right, - => left
*

        move.w sb.gtlin,a2
        jsr (a2)
        bne.s ret

        moveq #32,d7            d7.b = size
        moveq #2,d2             tidy stack: 8 - 2b
        subq.w #2,d3
        blt.s err_bp

        beq.s twopar

threepar
        move.l 8(a6,a1.l),d7    size
        addq.l #4,d2            additional amount

twopar
        movem.l (a6,a1.l),d0/d6

fixpar
        move.l #$ffff,d1        size mask
        lsr.l #4,d7             size = 2, 1, 0
        lsl.l #2,d7             size = 8, 4, 0
        beq.s l8

        cmpi.l #8,d7
        beq.s l32

        cmpi.l #4,d7
        beq.s l16
        bra.s err_bp

l8
        lsr.l #8,d1             make 8-bit

l16
        and.l d1,d0             make 8 or 16 bit
        and.l d1,d6

l32
        add.l d2,sb_arthp(a6)
        movea.l sb_arthp(a6),a1
        rts

*
err_bp
        moveq #err.ipar,d0

ret
        addq.l #4,sp
        rts

*
        end
